pub const SYMMETRIC_KEY_SIZE: u32 = 32;
pub const KUZNYECHIK_MGM_NONCE_SIZE: u32 = 16;
pub const KUZNYECHIK_MGM_TAG_SIZE: u32 = 16;
pub const KUZNYECHIK_MGM_ALIGNMENT: u32 = 1;
pub const KUZNYECHIK_MGM_SIZE: u32 = 160;
pub const KUZNYECHIK_CBC_NONCE_SIZE: u32 = 16;
pub const KUZNYECHIK_CBC_ALIGNMENT: u32 = 1;
pub const KUZNYECHIK_CBC_SIZE: u32 = 177;
pub const MAGMA_CBC_NONCE_SIZE: u32 = 8;
pub const MAGMA_CBC_ALIGNMENT: u32 = 4;
pub const MAGMA_CBC_SIZE: u32 = 44;
pub const KUZNYECHIK_CFB_NONCE_SIZE: u32 = 16;
pub const KUZNYECHIK_CFB_ALIGNMENT: u32 = 1;
pub const KUZNYECHIK_CFB_SIZE: u32 = 177;
pub const MAGMA_CFB_NONCE_SIZE: u32 = 8;
pub const MAGMA_CFB_ALIGNMENT: u32 = 4;
pub const MAGMA_CFB_SIZE: u32 = 44;
pub const KUZNYECHIK_BLOCK_SIZE: u32 = 16;
pub const KUZNYECHIK_ALIGNMENT: u32 = 1;
pub const KUZNYECHIK_SIZE: u32 = 160;
pub const MAGMA_BLOCK_SIZE: u32 = 8;
pub const MAGMA_ALIGNMENT: u32 = 4;
pub const MAGMA_SIZE: u32 = 32;
pub const KUZNYECHIK_CTR_NONCE_SIZE: u32 = 8;
pub const KUZNYECHIK_CTR_ALIGNMENT: u32 = 8;
pub const KUZNYECHIK_CTR_SIZE: u32 = 200;
pub const MAGMA_CTR_NONCE_SIZE: u32 = 4;
pub const MAGMA_CTR_ALIGNMENT: u32 = 4;
pub const MAGMA_CTR_SIZE: u32 = 52;
pub const KUZNYECHIK_ECB_ALIGNMENT: u32 = 1;
pub const KUZNYECHIK_ECB_SIZE: u32 = 160;
pub const MAGMA_ECB_ALIGNMENT: u32 = 4;
pub const MAGMA_ECB_SIZE: u32 = 32;
pub const EC_256_WIDTH: u32 = 32;
pub const EC_256_DOUBLE_WIDTH: u32 = 64;
pub const EC_256_PRIVATE_KEY_ALIGNMENT: u32 = 8;
pub const EC_256_PUBLIC_KEY_SIZE: u32 = 96;
pub const EC_256_PUBLIC_KEY_ALIGNMENT: u32 = 8;
pub const GOST3410_2012_512A: u32 = 643712121;
pub const GOST3410_2012_512B: u32 = 643712122;
pub const GOST3410_2012_512C: u32 = 643712123;
pub const EC_512_WIDTH: u32 = 64;
pub const EC_512_DOUBLE_WIDTH: u32 = 128;
pub const EC_512_PRIVATE_KEY_ALIGNMENT: u32 = 8;
pub const EC_512_PUBLIC_KEY_SIZE: u32 = 192;
pub const EC_512_PUBLIC_KEY_ALIGNMENT: u32 = 8;
pub const EC_ERR_CURVE_ID: i32 = -2;
pub const EC_ERR_PUBLIC_KEY_BYTES: i32 = -3;
pub const EC_ERR_PRIVATE_KEY_BYTES: i32 = -4;
pub const EC_ERR_SIGNATURE: i32 = -5;
pub const EC_ERR_BAD_RAND_BYTES: i32 = -6;
pub const EC_ERR_VKO_UKM: i32 = -7;
pub const STREEBOG256_RESULT_SIZE: u32 = 32;
pub const STREEBOG256_ALIGNMENT: u32 = 8;
pub const STREEBOG256_SIZE: u32 = 264;
pub const STREEBOG512_RESULT_SIZE: u32 = 64;
pub const STREEBOG512_ALIGNMENT: u32 = 8;
pub const STREEBOG512_SIZE: u32 = 264;
pub const KUZNYECHIK_MAC_RESULT_SIZE: u32 = 16;
pub const KUZNYECHIK_MAC_ALIGNMENT: u32 = 8;
pub const KUZNYECHIK_MAC_SIZE: u32 = 216;
pub const MAGMA_MAC_RESULT_SIZE: u32 = 8;
pub const MAGMA_MAC_ALIGNMENT: u32 = 8;
pub const MAGMA_MAC_SIZE: u32 = 64;
pub const KUZNYECHIK_OFB_NONCE_SIZE: u32 = 16;
pub const KUZNYECHIK_OFB_ALIGNMENT: u32 = 1;
pub const KUZNYECHIK_OFB_SIZE: u32 = 178;
pub const MAGMA_OFB_NONCE_SIZE: u32 = 8;
pub const MAGMA_OFB_ALIGNMENT: u32 = 4;
pub const MAGMA_OFB_SIZE: u32 = 44;
pub const GOST3410_2012_256A: u32 = 643712111;
pub const GOST3410_2012_256B: u32 = 643712112;
pub const GOST3410_2012_256C: u32 = 643712113;
pub const GOST3410_2012_256D: u32 = 643712114;
pub type KuznyechikMgm = [u8; 160usize];
pub type KuznyechikCbc = [u8; 177usize];
pub type MagmaCbc = [u8; 44usize];
pub type KuznyechikCfb = [u8; 177usize];
pub type MagmaCfb = [u8; 44usize];
pub type Kuznyechik = [u8; 160usize];
pub type Magma = [u8; 32usize];
pub type KuznyechikCtr = [u8; 200usize];
pub type MagmaCtr = [u8; 52usize];
pub type KuznyechikEcb = [u8; 160usize];
pub type MagmaEcb = [u8; 32usize];
pub type Ec256 = usize;
pub type Ec256PrivateKey = [u8; 32usize];
pub type Ec256PublicKey = [u8; 96usize];
pub type Ec512 = usize;
pub type Ec512PrivateKey = [u8; 64usize];
pub type Ec512PublicKey = [u8; 192usize];
pub type Streebog256 = [u8; 264usize];
pub type Streebog512 = [u8; 264usize];
pub type KuznyechikMac = [u8; 216usize];
pub type MagmaMac = [u8; 64usize];
pub type KuznyechikOfb = [u8; 178usize];
pub type MagmaOfb = [u8; 44usize];
extern "C" {
    pub fn kuznyechik_mgm_new(dst: *mut u8, key: *const u8);
}
extern "C" {
    pub fn kuznyechik_mgm_encrypt(
        cipher: *mut u8,
        nonce: *const u8,
        aad: *const u8,
        aad_len: usize,
        buf: *mut u8,
        buf_len: usize,
        tag: *mut u8,
    ) -> isize;
}
extern "C" {
    pub fn kuznyechik_mgm_decrypt(
        cipher: *mut u8,
        nonce: *const u8,
        aad: *const u8,
        aad_len: usize,
        buf: *mut u8,
        buf_len: usize,
        tag: *const u8,
    ) -> isize;
}
extern "C" {
    pub fn kuznyechik_mgm_drop(cipher: *mut u8);
}
extern "C" {
    pub fn kuznyechik_cbc_new(dst: *mut u8, key: *const u8, nonce: *const u8);
}
extern "C" {
    pub fn kuznyechik_cbc_encrypt_blocks(cipher: *mut u8, blocks: *mut u8, blocks_len: usize);
}
extern "C" {
    pub fn kuznyechik_cbc_decrypt_blocks(cipher: *mut u8, blocks: *mut u8, blocks_len: usize);
}
extern "C" {
    pub fn kuznyechik_cbc_encrypt_pad(
        cipher: *mut u8,
        buf: *mut u8,
        buf_len: usize,
        pos: usize,
    ) -> isize;
}
extern "C" {
    pub fn kuznyechik_cbc_decrypt_pad(cipher: *mut u8, buf: *mut u8, buf_len: usize) -> isize;
}
extern "C" {
    pub fn kuznyechik_cbc_drop(cipher: *mut u8);
}
extern "C" {
    pub fn magma_cbc_new(dst: *mut u8, key: *const u8, nonce: *const u8);
}
extern "C" {
    pub fn magma_cbc_encrypt_blocks(cipher: *mut u8, blocks: *mut u8, blocks_len: usize);
}
extern "C" {
    pub fn magma_cbc_decrypt_blocks(cipher: *mut u8, blocks: *mut u8, blocks_len: usize);
}
extern "C" {
    pub fn magma_cbc_encrypt_pad(
        cipher: *mut u8,
        buf: *mut u8,
        buf_len: usize,
        pos: usize,
    ) -> isize;
}
extern "C" {
    pub fn magma_cbc_decrypt_pad(cipher: *mut u8, buf: *mut u8, buf_len: usize) -> isize;
}
extern "C" {
    pub fn magma_cbc_drop(cipher: *mut u8);
}
extern "C" {
    pub fn kuznyechik_cfb_new(dst: *mut u8, key: *const u8, nonce: *const u8);
}
extern "C" {
    pub fn kuznyechik_cfb_encrypt(cipher: *mut u8, buf: *mut u8, buf_len: usize);
}
extern "C" {
    pub fn kuznyechik_cfb_decrypt(cipher: *mut u8, buf: *mut u8, buf_len: usize);
}
extern "C" {
    pub fn kuznyechik_cfb_drop(cipher: *mut u8);
}
extern "C" {
    pub fn magma_cfb_new(dst: *mut u8, key: *const u8, nonce: *const u8);
}
extern "C" {
    pub fn magma_cfb_encrypt(cipher: *mut u8, buf: *mut u8, buf_len: usize);
}
extern "C" {
    pub fn magma_cfb_decrypt(cipher: *mut u8, buf: *mut u8, buf_len: usize);
}
extern "C" {
    pub fn magma_cfb_drop(cipher: *mut u8);
}
extern "C" {
    pub fn kuznyechik_new(dst: *mut u8, key: *const u8);
}
extern "C" {
    pub fn kuznyechik_encrypt_block(cipher: *mut u8, block: *mut u8);
}
extern "C" {
    pub fn kuznyechik_decrypt_block(cipher: *mut u8, block: *mut u8);
}
extern "C" {
    pub fn kuznyechik_encrypt_blocks(cipher: *mut u8, blocks: *mut u8, len: usize);
}
extern "C" {
    pub fn kuznyechik_decrypt_blocks(cipher: *mut u8, blocks: *mut u8, len: usize);
}
extern "C" {
    pub fn kuznyechik_drop(cipher: *mut u8);
}
extern "C" {
    pub fn magma_new(dst: *mut u8, key: *const u8);
}
extern "C" {
    pub fn magma_encrypt_block(cipher: *mut u8, block: *mut u8);
}
extern "C" {
    pub fn magma_decrypt_block(cipher: *mut u8, block: *mut u8);
}
extern "C" {
    pub fn magma_encrypt_blocks(cipher: *mut u8, blocks: *mut u8, len: usize);
}
extern "C" {
    pub fn magma_decrypt_blocks(cipher: *mut u8, blocks: *mut u8, len: usize);
}
extern "C" {
    pub fn magma_drop(cipher: *mut u8);
}
extern "C" {
    pub fn kuznyechik_ctr_new(dst: *mut u8, key: *const u8, nonce: *const u8);
}
extern "C" {
    pub fn kuznyechik_ctr_apply_keystream(cipher: *mut u8, buf: *mut u8, buf_len: usize) -> isize;
}
extern "C" {
    pub fn kuznyechik_ctr_seek(cipher: *mut u8, pos: u64) -> isize;
}
extern "C" {
    pub fn kuznyechik_ctr_get_pos(cipher: *mut u8) -> u64;
}
extern "C" {
    pub fn kuznyechik_ctr_drop(cipher: *mut u8);
}
extern "C" {
    pub fn magma_ctr_new(dst: *mut u8, key: *const u8, nonce: *const u8);
}
extern "C" {
    pub fn magma_ctr_apply_keystream(cipher: *mut u8, buf: *mut u8, buf_len: usize) -> isize;
}
extern "C" {
    pub fn magma_ctr_seek(cipher: *mut u8, pos: u64) -> isize;
}
extern "C" {
    pub fn magma_ctr_get_pos(cipher: *mut u8) -> u64;
}
extern "C" {
    pub fn magma_ctr_drop(cipher: *mut u8);
}
extern "C" {
    pub fn kuznyechik_ecb_new(dst: *mut u8, key: *const u8);
}
extern "C" {
    pub fn kuznyechik_ecb_encrypt_blocks(cipher: *mut u8, blocks: *mut u8, blocks_len: usize);
}
extern "C" {
    pub fn kuznyechik_ecb_decrypt_blocks(cipher: *mut u8, blocks: *mut u8, blocks_len: usize);
}
extern "C" {
    pub fn kuznyechik_ecb_encrypt_pad(
        cipher: *mut u8,
        buf: *mut u8,
        buf_len: usize,
        pos: usize,
    ) -> isize;
}
extern "C" {
    pub fn kuznyechik_ecb_decrypt_pad(cipher: *mut u8, buf: *mut u8, buf_len: usize) -> isize;
}
extern "C" {
    pub fn kuznyechik_ecb_drop(cipher: *mut u8);
}
extern "C" {
    pub fn magma_ecb_new(dst: *mut u8, key: *const u8);
}
extern "C" {
    pub fn magma_ecb_encrypt_blocks(cipher: *mut u8, blocks: *mut u8, blocks_len: usize);
}
extern "C" {
    pub fn magma_ecb_decrypt_blocks(cipher: *mut u8, blocks: *mut u8, blocks_len: usize);
}
extern "C" {
    pub fn magma_ecb_encrypt_pad(
        cipher: *mut u8,
        buf: *mut u8,
        buf_len: usize,
        pos: usize,
    ) -> isize;
}
extern "C" {
    pub fn magma_ecb_decrypt_pad(cipher: *mut u8, buf: *mut u8, buf_len: usize) -> isize;
}
extern "C" {
    pub fn magma_ecb_drop(cipher: *mut u8);
}
extern "C" {
    pub fn ec256_gen_private_key(cid: Ec256, sk: *mut u8, rand_bytes: *const u8) -> isize;
}
extern "C" {
    pub fn ec256_get_public_key(cid: Ec256, sk: *mut u8, pk: *mut u8) -> isize;
}
extern "C" {
    pub fn ec256_private_key_from_bytes(cid: Ec256, bytes: *const u8, sk: *mut u8) -> isize;
}
extern "C" {
    pub fn ec256_private_key_to_bytes(cid: Ec256, sk: *mut u8, bytes: *mut u8) -> isize;
}
extern "C" {
    pub fn ec256_dsa_sign_hash(
        cid: Ec256,
        sk: *mut u8,
        hash: *const u8,
        rand_bytes: *const u8,
        signature: *mut u8,
    ) -> isize;
}
extern "C" {
    pub fn ec256_dsa_sign(
        cid: Ec256,
        sk: *mut u8,
        msg: *const u8,
        msg_len: usize,
        rand_bytes: *const u8,
        signature: *mut u8,
    ) -> isize;
}
extern "C" {
    pub fn ec256_public_key_from_bytes(cid: Ec256, bytes: *const u8, pk: *mut u8) -> isize;
}
extern "C" {
    pub fn ec256_public_key_to_bytes(cid: Ec256, pk: *mut u8, bytes: *mut u8) -> isize;
}
extern "C" {
    pub fn ec256_dsa_verify_hash(
        cid: Ec256,
        pk: *mut u8,
        hash: *const u8,
        signature: *const u8,
    ) -> isize;
}
extern "C" {
    pub fn ec256_dsa_verify(
        cid: Ec256,
        pk: *mut u8,
        msg: *const u8,
        msg_len: usize,
        signature: *const u8,
    ) -> isize;
}
extern "C" {
    pub fn ec256_vko256(
        cid: Ec256,
        sk: *mut u8,
        pk: *mut u8,
        ukm: *const u8,
        out: *mut u8,
    ) -> isize;
}
extern "C" {
    pub fn ec256_private_key_drop(sk: *mut u8);
}
extern "C" {
    pub fn ec512_gen_private_key(cid: Ec512, sk: *mut u8, rand_bytes: *const u8) -> isize;
}
extern "C" {
    pub fn ec512_get_public_key(cid: Ec512, sk: *mut u8, pk: *mut u8) -> isize;
}
extern "C" {
    pub fn ec512_private_key_from_bytes(cid: Ec512, bytes: *const u8, sk: *mut u8) -> isize;
}
extern "C" {
    pub fn ec512_private_key_to_bytes(cid: Ec512, sk: *mut u8, bytes: *mut u8) -> isize;
}
extern "C" {
    pub fn ec512_dsa_sign_hash(
        cid: Ec512,
        sk: *mut u8,
        hash: *const u8,
        rand_bytes: *const u8,
        signature: *mut u8,
    ) -> isize;
}
extern "C" {
    pub fn ec512_dsa_sign(
        cid: Ec512,
        sk: *mut u8,
        msg: *const u8,
        msg_len: usize,
        rand_bytes: *const u8,
        signature: *mut u8,
    ) -> isize;
}
extern "C" {
    pub fn ec512_public_key_from_bytes(cid: Ec512, bytes: *const u8, pk: *mut u8) -> isize;
}
extern "C" {
    pub fn ec512_public_key_to_bytes(cid: Ec512, pk: *mut u8, bytes: *mut u8) -> isize;
}
extern "C" {
    pub fn ec512_dsa_verify_hash(
        cid: Ec512,
        pk: *mut u8,
        hash: *const u8,
        signature: *const u8,
    ) -> isize;
}
extern "C" {
    pub fn ec512_dsa_verify(
        cid: Ec512,
        pk: *mut u8,
        msg: *const u8,
        msg_len: usize,
        signature: *const u8,
    ) -> isize;
}
extern "C" {
    pub fn ec512_vko512(
        cid: Ec512,
        sk: *mut u8,
        pk: *mut u8,
        ukm: *const u8,
        out: *mut u8,
    ) -> isize;
}
extern "C" {
    pub fn ec512_vko256(
        cid: Ec512,
        sk: *mut u8,
        pk: *mut u8,
        ukm: *const u8,
        out: *mut u8,
    ) -> isize;
}
extern "C" {
    pub fn ec512_private_key_drop(sk: *mut u8);
}
extern "C" {
    pub fn streebog256_new(dst: *mut u8);
}
extern "C" {
    pub fn streebog256_digest(msg: *const u8, len: usize, res: *mut u8);
}
extern "C" {
    pub fn streebog256_update(state: *mut u8, msg: *const u8, len: usize);
}
extern "C" {
    pub fn streebog256_finalize(state: *mut u8, res: *mut u8);
}
extern "C" {
    pub fn streebog256_finalize_reset(state: *mut u8, res: *mut u8);
}
extern "C" {
    pub fn streebog256_reset(state: *mut u8);
}
extern "C" {
    pub fn streebog256_drop(state: *mut u8);
}
extern "C" {
    pub fn streebog512_new(dst: *mut u8);
}
extern "C" {
    pub fn streebog512_digest(msg: *const u8, len: usize, res: *mut u8);
}
extern "C" {
    pub fn streebog512_update(state: *mut u8, msg: *const u8, len: usize);
}
extern "C" {
    pub fn streebog512_finalize(state: *mut u8, res: *mut u8);
}
extern "C" {
    pub fn streebog512_finalize_reset(state: *mut u8, res: *mut u8);
}
extern "C" {
    pub fn streebog512_reset(state: *mut u8);
}
extern "C" {
    pub fn streebog512_drop(state: *mut u8);
}
extern "C" {
    pub fn kuznyechik_mac_new(dst: *mut u8, key: *const u8);
}
extern "C" {
    pub fn kuznyechik_mac_update(state: *mut u8, msg: *const u8, len: usize);
}
extern "C" {
    pub fn kuznyechik_mac_finalize(state: *mut u8, res: *mut u8);
}
extern "C" {
    pub fn kuznyechik_mac_finalize_reset(state: *mut u8, res: *mut u8);
}
extern "C" {
    pub fn kuznyechik_mac_verify(state: *mut u8, code: *const u8) -> bool;
}
extern "C" {
    pub fn kuznyechik_mac_reset(state: *mut u8);
}
extern "C" {
    pub fn kuznyechik_mac_drop(state: *mut u8);
}
extern "C" {
    pub fn magma_mac_new(dst: *mut u8, key: *const u8);
}
extern "C" {
    pub fn magma_mac_update(state: *mut u8, msg: *const u8, len: usize);
}
extern "C" {
    pub fn magma_mac_finalize(state: *mut u8, res: *mut u8);
}
extern "C" {
    pub fn magma_mac_finalize_reset(state: *mut u8, res: *mut u8);
}
extern "C" {
    pub fn magma_mac_verify(state: *mut u8, code: *const u8) -> bool;
}
extern "C" {
    pub fn magma_mac_reset(state: *mut u8);
}
extern "C" {
    pub fn magma_mac_drop(state: *mut u8);
}
extern "C" {
    pub fn kuznyechik_ofb_new(dst: *mut u8, key: *const u8, nonce: *const u8);
}
extern "C" {
    pub fn kuznyechik_ofb_apply_keystream(cipher: *mut u8, buf: *mut u8, buf_len: usize);
}
extern "C" {
    pub fn kuznyechik_ofb_drop(cipher: *mut u8);
}
extern "C" {
    pub fn magma_ofb_new(dst: *mut u8, key: *const u8, nonce: *const u8);
}
extern "C" {
    pub fn magma_ofb_apply_keystream(cipher: *mut u8, buf: *mut u8, buf_len: usize);
}
extern "C" {
    pub fn magma_ofb_drop(cipher: *mut u8);
}
