#include "catch_amalgamated.hpp"
#include "gostcrypto.hpp"
#include "common.hpp"

TEST_CASE("Cipher64")
{
    auto key = random_array<SYMMETRIC_KEY_SIZE>();
    Magma_t magma(key);
    Magma_t another_magma(key.data());
    REQUIRE(memcmp(static_cast<void *>(&magma), static_cast<void *>(&another_magma), sizeof(Magma_t)) == 0);

    uint8_t block[MAGMA_BLOCK_SIZE] = {};
    uint8_t expected[MAGMA_BLOCK_SIZE] = {};

    magma.encrypt_block(block);
    REQUIRE(0 != memcmp(expected, block, MAGMA_BLOCK_SIZE));

    magma.decrypt_block(block);
    REQUIRE(0 == memcmp(expected, block, MAGMA_BLOCK_SIZE));
}

TEST_CASE("Cipher128")
{
    auto key = random_array<SYMMETRIC_KEY_SIZE>();
    Kuznyechik_t kuznyechik(key);
    Kuznyechik_t another_kuznyechik(key.data());
    REQUIRE(memcmp(static_cast<void *>(&kuznyechik), static_cast<void *>(&another_kuznyechik), sizeof(Kuznyechik_t)) == 0);

    uint8_t block[KUZNYECHIK_BLOCK_SIZE] = {};
    uint8_t expected[KUZNYECHIK_BLOCK_SIZE] = {};

    kuznyechik.encrypt_block(block);
    REQUIRE(0 != memcmp(expected, block, KUZNYECHIK_BLOCK_SIZE));

    kuznyechik.decrypt_block(block);
    REQUIRE(0 == memcmp(expected, block, KUZNYECHIK_BLOCK_SIZE));
}
