#include "catch_amalgamated.hpp"
#include "gostcrypto.hpp"
#include "common.hpp"

TEST_CASE("KuznyechikMgm")
{
    auto key = random_array<SYMMETRIC_KEY_SIZE>();
    KuznyechikMgm_t kuznyechik_mgm(key);

    const uint8_t nonce[KUZNYECHIK_MGM_NONCE_SIZE] = {};
    constexpr uintptr_t aad_len = 30;
    uint8_t aad[aad_len] = {};

    constexpr uintptr_t buf_len = 100;
    uint8_t buf1[buf_len] = {};
    uint8_t expected[buf_len] = {};

    uint8_t tag[KUZNYECHIK_MGM_TAG_SIZE] = {};

    kuznyechik_mgm.encrypt(nonce, aad, aad_len, buf1, buf_len, tag);

    REQUIRE(0 != memcmp(buf1, expected, buf_len));

    kuznyechik_mgm.decrypt(nonce, aad, aad_len, buf1, buf_len, tag);

    REQUIRE(0 == memcmp(buf1, expected, buf_len));
}
