#! /bin/bash
set -eo pipefail

root='../..'

# rebuild gostcrypto lib
(cd $root/libgostcrypto && cargo build)

# build tests
warning_flags="-Werror -Wall -Wextra -Wpedantic -Wold-style-cast"
g++ $warning_flags -I $root/libgostcrypto/ ./*.cpp  $root/target/debug/libgostcrypto.a -o test

# run tests
./test --reporter automake

# clean
rm test
